Index: drivers/video/ts7kvfb.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/video/ts7kvfb.c,v
retrieving revision 1.1
retrieving revision 1.10
diff -u -r1.1 -r1.10
--- drivers/video/ts7kvfb.c	8 Sep 2005 00:39:31 -0000	1.1
+++ drivers/video/ts7kvfb.c	20 Sep 2007 18:05:10 -0000	1.10
@@ -4,9 +4,9 @@
  *  Created 24 Aug 2005 by Eddie Dawydiuk
  *
  *  Based on:
- *   linux/drivers/video/skeletonfb.c 
+ *   linux/drivers/video/skeletonfb.c
  *     Created 28 Dec 1997 by Geert Uytterhoeven
- *     
+ *
  *   linux/drivers/video/au1100fb.c
  *     Author: MontaVista Software, Inc.
  *
@@ -25,45 +25,37 @@
 #include <linux/delay.h>
 #include <linux/fb.h>
 #include <linux/init.h>
-
+#include <linux/delay.h>
+#include <linux/ioport.h>
 #include <video/fbcon.h>
 #include <video/fbcon-cfb16.h>
+#include "ts7kvfb.h"
 
 #ifdef CONFIG_LOAD_FPGA
-	#include "load_fpga.c"
+#include "load_fpga.c"
 #endif
 
-#define XRES  640
-#define YRES  480 
-#define BPP   16
-
-#define CONFIG_REG  0xF0
-#define DONE_MSK    0x80
-
-#define VIDEOMEMORYSIZE (1*1024*1024)
-
 struct ts7kvfb_info {
-
 	struct fb_info_gen gen;
 	unsigned long fb_virt_start;
 	unsigned long fb_size;
 	unsigned long fb_phys;
+	volatile unsigned short *fpga_regs;
+	unsigned int page;
+	struct { unsigned red, green, blue, pad; } palette[16];
+	int xres;
+	int yres;
+	char id;
 
-	struct { unsigned red, green, blue, pad; } palette[256];
 	u16 fbcon_cmap16[16];
+	struct display_switch dispw;
 
-struct display_switch dispw;
 };
 
-
 struct ts7kvfb_par {
-
 	struct fb_var_screeninfo var;
-	int line_length;  //in bytes
-	int cmap_len;
 };
 
-
 static struct ts7kvfb_info fb_info;
 static struct ts7kvfb_par current_par;
 static struct display disp;
@@ -72,7 +64,6 @@
 int ts7kvfb_setup(char *options);
 static int ts7kv_blank(int blank_mode, struct fb_info_gen *info);
 
-
 static struct fb_ops ts7kvfb_ops = {
 	owner:		THIS_MODULE,
 	fb_get_fix:	fbgen_get_fix,
@@ -84,36 +75,62 @@
 	fb_pan_display:	fbgen_pan_display,
 };
 
+void ts7kv_blt(int src, int dest, int width, int height, int pxfill)
+{
+	unsigned short swin = fb_info.fpga_regs[DEVSEL];
+	unsigned short vidctrl;
+	unsigned int direction = 0;
+
+	if (pxfill == 0 && src < dest) {
+		src += (height - 1) * fb_info.xres;
+		dest += (height - 1) * fb_info.xres;
+		direction = 1;
+	}
+
+	fb_info.fpga_regs[DEVSEL] = 0x50;
+	// XXX: This should probably be a read-modify-write.  --JO
+	vidctrl = fb_info.fpga_regs[VIDCTRL];
+	fb_info.fpga_regs[VIDCTRL] = (vidctrl & 0xff3f) | (direction << 7) | (pxfill << 6);
+	fb_info.fpga_regs[BLTCTRL] = (src >> 16) | ((dest >> 16) << 6) | ((width >> 7) << 13);
+	fb_info.fpga_regs[BLTSZ] = (height & 0x1ff) | (width << 9);
+	fb_info.fpga_regs[SRCBLT] = src & 0xffff;
+	fb_info.fpga_regs[DSTBLT] = dest & 0xffff;
+	while (fb_info.fpga_regs[VIDCTRL] & 0x400);
 
+	fb_info.fpga_regs[DEVSEL] = swin;
+}
 
 
-    /*
-     * Text mode accelerated functions
-     */
-
-static void
-fbcon_ts7kv_bmove(struct display *p, int sy, int sx, int dy, int dx,
-                        int height, int width)
+static void fbcon_ts7kv_bmove(struct display *p, int sy, int sx, int dy, int dx,
+	                        int height, int width)
 {
-printk("fbcon_ts7kv_bmove:...\n");
-/*
-    sx     *= fontwidth(p);
-    sy     *= fontheight(p);
-    dx     *= fontwidth(p);
-    dy     *= fontheight(p);
-    width  *= fontwidth(p);
-    height *= fontheight(p);
-
-    //aty128_rectcopy(sx, sy, dx, dy, width, height,
-     //                   (struct fb_info_aty128 *)p->fb_info);
-*/
+	unsigned int src = sy * fontheight(p) * fb_info.xres + sx * fontwidth(p);
+	unsigned int dst = dy * fontheight(p) * fb_info.xres + dx * fontwidth(p);
+
+	width  *= fontwidth(p);
+	height *= fontheight(p);
+
+	ts7kv_blt(src, dst, width - 1, height, 0);
+}
+
+void fbcon_ts7kv_clear(struct vc_data *conp, struct display *p, int sy, int sx,
+                       int height, int width)
+{
+	unsigned int dst = sy * fontheight(p) * fb_info.xres + sx * fontwidth(p);
+	unsigned short bgcolor;
+
+	width  *= fontwidth(p);
+	height *= fontheight(p);
+	bgcolor = ((u16 *)p->dispsw_data)[attr_bgcol_ec(p, conp)];
+
+	ts7kv_blt(bgcolor, dst, width - 1, height, 1);
 }
 
 
 struct display_switch fbcon_ts7kv = {
     setup:              fbcon_cfb16_setup,
     bmove:              fbcon_ts7kv_bmove,
-    clear:              fbcon_cfb16_clear,
+    clear:              fbcon_ts7kv_clear,
     putc:               fbcon_cfb16_putc,
     putcs:              fbcon_cfb16_putcs,
     revc:               fbcon_cfb16_revc,
@@ -121,13 +138,11 @@
     fontwidthmask:      FONTWIDTH(4)|FONTWIDTH(8)|FONTWIDTH(12)|FONTWIDTH(16)
 };
 
-
 static void ts7kv_detect(void)
 {
-
 }
 
-static int ts7kv_encode_fix(struct fb_fix_screeninfo *fix, 
+static int ts7kv_encode_fix(struct fb_fix_screeninfo *fix,
 				const void *_par, struct fb_info_gen *_info)
 {
 	struct ts7kvfb_info *info = (struct ts7kvfb_info *) _info;
@@ -142,9 +157,8 @@
 	fix->ywrapstep = 0;
 	fix->xpanstep = 0;
 	fix->ypanstep = 0;
-	fix->line_length = current_par.line_length;
-
-fix->accel = FB_ACCELF_TEXT;
+	fix->line_length = fb_info.xres * 2;
+	fix->accel = FB_ACCELF_TEXT;
 
 	return 0;
 }
@@ -152,12 +166,12 @@
 static void set_color_bitfields(struct fb_var_screeninfo *var)
 {
 	var->red.offset = 11;
-	var->green.offset = 5;
+	var->green.offset = 6;
 	var->blue.offset = 0;
 	var->transp.offset = 0;
 
 	var->red.length = 5;
-	var->green.length = 5;
+	var->green.length = 6;
 	var->blue.length = 5;
 	var->transp.length = 0;
 
@@ -167,38 +181,34 @@
 	var->transp.msb_right = 0;
 }
 
-static int ts7kv_decode_var(const struct fb_var_screeninfo *var, 
+static int ts7kv_decode_var(const struct fb_var_screeninfo *var,
 				void *_par, struct fb_info_gen *_info)
 {
 	struct ts7kvfb_par *par = (struct ts7kvfb_par *)_par;
 
-	if (var->xres != XRES || var->yres != YRES) 
+	if (var->xres != fb_info.xres || var->yres != fb_info.yres)
 		return -EINVAL;
 
-	if(var->bits_per_pixel != BPP) 
+	if(var->bits_per_pixel != BPP)
 		return -EINVAL;
 
 	memset(par, 0, sizeof(struct ts7kvfb_par));
-	par->var = *var; 
-
+	par->var = *var;
 	par->var.bits_per_pixel = 16;
 	set_color_bitfields(&par->var);
-	par->cmap_len = (par->var.bits_per_pixel == 8) ? 256 : 16;
 
 	return 0;
 }
 
-static int ts7kv_encode_var(struct fb_var_screeninfo *var, 
+static int ts7kv_encode_var(struct fb_var_screeninfo *var,
 	const void *par, struct fb_info_gen *info)
 {
 	*var = ((struct ts7kvfb_par *)par)->var;
-
 	return 0;
 }
 
 static void ts7kv_get_par(void *_par, struct fb_info_gen *_info)
 {
-
 	*(struct ts7kvfb_par *)_par = current_par;
 }
 
@@ -213,7 +223,7 @@
 {
 	struct ts7kvfb_info* i = (struct ts7kvfb_info*)info;
 
-	if (regno > 255)
+	if (regno > 15)
 		return 1;
 
 	*red    = i->palette[regno].red;
@@ -225,12 +235,12 @@
 }
 
 static int ts7kv_setcolreg(unsigned regno, unsigned red, unsigned green,
-			 	unsigned blue, unsigned transp, 
+			 	unsigned blue, unsigned transp,
 				struct fb_info *info)
 {
 	struct ts7kvfb_info* i = (struct ts7kvfb_info *)info;
 
-	if (regno > 255)
+	if (regno > 15)
 		return 1;
 
 	i->palette[regno].red    = red;
@@ -239,10 +249,9 @@
 
 	i->fbcon_cmap16[regno] =
 		((red & 0xf800) >> 0) |
-		((green & 0xf800) >> 6) |
+		((green & 0xf800) >> 5) |
 		((blue & 0xf800) >> 11);
 
-
 	return 0;
 }
 
@@ -251,75 +260,138 @@
 {
 	return 0;
 }
+
+/*
+ *  Blank the screen if blank_mode != 0, else unblank. If blank == NULL
+ *  then the caller blanks by setting the CLUT (Color Look Up Table) to all
+ *  black. Return 0 if blanking succeeded, != 0 if un-/blanking failed due
+ *  to e.g. a video mode which doesn't support it. Implements VESA suspend
+ *  and powerdown modes on hardware that supports disabling hsync/vsync:
+ *    blank_mode == 2: suspend vsync
+ *    blank_mode == 3: suspend hsync
+ *    blank_mode == 4: powerdown
+ */
 static int ts7kv_blank(int blank_mode, struct fb_info_gen *info)
 {
+	unsigned short swin = fb_info.fpga_regs[DEVSEL];
+
+	if(fb_info.id == LCD_MONO)
+		return 0;
+
+	fb_info.fpga_regs[DEVSEL] = 0x50;
+	switch (blank_mode) {
+	case 0:
+		fb_info.fpga_regs[VIDCTRL] = 0x300;
+		break;
+	case 1:
+	case 2:
+		fb_info.fpga_regs[VIDCTRL] = 0x200;
+		break;
+	case 3:
+		fb_info.fpga_regs[VIDCTRL] = 0x100;
+		break;
+	case 4:
+		fb_info.fpga_regs[VIDCTRL] = 0x0;
+		break;
+	}
+
+	fb_info.fpga_regs[DEVSEL] = swin;
+
 	return 0;
 }
 
 static void ts7kv_set_disp(const void *unused, struct display *disp,
 			 struct fb_info_gen *info)
 {
-
 	disp->screen_base = (char *)fb_info.fb_virt_start;
-
-//disp->dispsw = &fbcon_cfb16;
-disp->dispsw = &fbcon_ts7kv;
-
+	disp->dispsw = &fbcon_ts7kv;
 	disp->dispsw_data = fb_info.fbcon_cmap16;
 	disp->scrollmode = 0;
 }
 
-
-static struct fbgen_hwswitch ts7kv_switch = 
+static struct fbgen_hwswitch ts7kv_switch =
 {
-	ts7kv_detect, 
-	ts7kv_encode_fix, 
-	ts7kv_decode_var, 
-	ts7kv_encode_var, 
-	ts7kv_get_par, 
-	ts7kv_set_par, 
-	ts7kv_getcolreg, 
-	ts7kv_setcolreg, 
-	ts7kv_pan_display, 
-	ts7kv_blank, 
+	ts7kv_detect,
+	ts7kv_encode_fix,
+	ts7kv_decode_var,
+	ts7kv_encode_var,
+	ts7kv_get_par,
+	ts7kv_set_par,
+	ts7kv_getcolreg,
+	ts7kv_setcolreg,
+	ts7kv_pan_display,
+	ts7kv_blank,
 	ts7kv_set_disp
 };
 
-
 int __init ts7kvfb_init(void)
 {
 	int return_val = 0;
-	
-	#ifdef CONFIG_LOAD_FPGA
-
-		//Load the firmware
-		init_fpga();
-		return_val = write_bitstream();		
+	unsigned long base_addr;
+	int i;
 
-		if(return_val != 0)
-			printk("Error loading firmware...\n");
-	#endif
-
-	#ifndef CONFIG_LOAD_FPGA
+#ifdef CONFIG_LOAD_FPGA
+	//Load the firmware
+	init_fpga();
+	return_val = write_bitstream();
+	if(return_val != 0) {
+		printk("Error loading firmware...\n");
+		return -1;
+	}
+#endif
 
-		//Ensure the firmware has been loaded...
-		if((inb(TS7XXX_IOMEM + CONFIG_REG) & DONE_MSK) != DONE_MSK)
+	fb_info.fb_size = VIDEOMEMORYSIZE;
+	for (i=0;i<5;i++)
+	{
+		if (i==4) {
+			printk("TS7KV board was not found or firmware not loaded!\n");
+			return -1;
+		}
+		base_addr = TS7XXX_IOMEM|BASE_ADDR + (i*BASE_SIZE);
+		if ( (inb(base_addr|ID0_REG) == TS7KV_ID0) &&
+			(inb(base_addr|ID1_REG) == TS7KV_ID1) &&
+			((inb(base_addr|CTR_REG0))&DONE_MSK == DONE_MSK) )
 		{
-			printk("Error firmware has not yet been loaded...\n");
-			return_val = -1;
+			fb_info.fb_virt_start = IO_ADDRESS(TS7XXX_IO16_BASE + 0x1800000 + (i*VIDEOMEMORYSIZE));
+			if (check_mem_region(fb_info.fb_virt_start, fb_info.fb_size))
+				continue;
+			request_mem_region(fb_info.fb_virt_start, fb_info.fb_size, "TS-7KV");
+			fb_info.fb_phys = 0x21800000 + (i*VIDEOMEMORYSIZE);
+			fb_info.fpga_regs = (short *)IO_ADDRESS(TS7XXX_IO16_BASE +
+				TS7XXX_ISAIO + REGS_ADDR + (i*REGS_SIZE));
+			printk(KERN_INFO "Framebuffer at 0x%lx allocated for TS-7KV with jumpers #1:%s #2:%s\n",
+				fb_info.fb_phys, ((base_addr&0x8) ? "ON" : "OFF"), ((base_addr&0x10) ? "ON" : "OFF"));
+			break;
 		}
-	#endif
+	}
 
-	fb_info.fb_size = VIDEOMEMORYSIZE;
+	unsigned short swin = fb_info.fpga_regs[DEVSEL];
+	fb_info.fpga_regs[DEVSEL] = 0x50;
 
-	current_par.var.xres = XRES;
-	current_par.var.xres_virtual = XRES;
-	current_par.var.yres = YRES;
-	current_par.var.yres_virtual = YRES;
+	if(fb_info.fpga_regs[BLTSZ] == CRT) 
+	{
+		fb_info.xres = 640;
+		fb_info.yres = 480;
+		fb_info.id = CRT;
+	}else if(fb_info.fpga_regs[BLTSZ] == LCD_MONO) 
+	{
+		fb_info.xres = 320;
+		fb_info.yres = 240;
+		fb_info.id = LCD_MONO;
+	}else
+	{
+		printk("This version doesn't support the current bitstream.\n");
+		return -1;
+	}		
+
+	current_par.var.xres = fb_info.xres;
+	current_par.var.xres_virtual = fb_info.xres;
+	current_par.var.yres = fb_info.yres;
+	current_par.var.yres_virtual = fb_info.yres;
 	current_par.var.bits_per_pixel = BPP;
 
 	//timing information
-	current_par.var.pixclock = 32000;   //picoseconds
+	current_par.var.pixclock = 31746;    //picoseconds
 	current_par.var.left_margin =  128;  //pixels, (back porch)
 	current_par.var.right_margin = 24;   //pixels, (front porch)
 	current_par.var.upper_margin = 28;   //pixel lines, (back porch)
@@ -327,56 +399,52 @@
 	current_par.var.hsync_len = 40;      //pixels
 	current_par.var.vsync_len = 3;       //pixel lines
 
-	current_par.line_length = XRES * BPP / 8; /* in bytes */
-
-//EWD:TODO these addresses need to change based 
-//upon what the jumper settings are
-	fb_info.fb_virt_start = IO_ADDRESS(TS7XXX_IO16_BASE + 0x1800000);
-	fb_info.fb_phys = 0x21800000;
+	udelay(350);
 
-        memset((void *)fb_info.fb_virt_start, 0, fb_info.fb_size);
+	{
+		fb_info.fpga_regs[VIDCTRL] = 0x200;
+		mdelay(100);
+		fb_info.fpga_regs[VIDCTRL] = 0x300;
+		fb_info.fpga_regs[DEVSEL] = swin;
+		fb_info.page = 0;
+	}
 
-        fb_info.gen.parsize = sizeof(struct ts7kvfb_par);
-        fb_info.gen.fbhw = &ts7kv_switch;
+	// Blank screen
+	ts7kv_blt(0, 0, 639, 480, 1);
 
 	strcpy(fb_info.gen.info.modename, "TS-7KV");
+	strcpy(fb_info.gen.info.fontname, "Acorn8x8");
+	fb_info.gen.parsize = sizeof(struct ts7kvfb_par);
+	fb_info.gen.fbhw = &ts7kv_switch;
 	fb_info.gen.info.changevar = NULL;
 	fb_info.gen.info.node = -1;
-
 	fb_info.gen.info.fbops = &ts7kvfb_ops;
-        fb_info.gen.info.disp = &disp;
-        fb_info.gen.info.switch_con = &fbgen_switch;
-        fb_info.gen.info.updatevar = &fbgen_update_var;
-        fb_info.gen.info.blank = &fbgen_blank;
-        fb_info.gen.info.flags = FBINFO_FLAG_DEFAULT;
+	fb_info.gen.info.disp = &disp;
+	fb_info.gen.info.switch_con = &fbgen_switch;
+	fb_info.gen.info.updatevar = &fbgen_update_var;
+	fb_info.gen.info.blank = &fbgen_blank;
+	fb_info.gen.info.flags = FBINFO_FLAG_DEFAULT;
 
 	/* This should give a reasonable default video mode */
 	fbgen_get_var(&disp.var, -1, &fb_info.gen.info);
 	fbgen_do_set_var(&disp.var, 1, &fb_info.gen);
 	fbgen_set_disp(-1, &fb_info.gen);
-	fbgen_install_cmap(0, &fb_info.gen);
 
 	if (register_framebuffer(&fb_info.gen.info) < 0)
 		return -EINVAL;
 
-	printk(KERN_INFO "fb%d: %s frame buffer device\n", 
+	printk(KERN_INFO "fb%d: %s frame buffer device\n",
 		GET_FB_IDX(fb_info.gen.info.node), fb_info.gen.info.modename);
 
 	return return_val;
 }
 
-
 int __init ts7kvfb_setup(char *options)
 {
 	/* Parse user speficied options (`video=ts7kvfb:') */
 	return 0;
 }
 
-
-
-
-
-
 #ifdef MODULE
 MODULE_LICENSE("GPL");
 int init_module(void)
@@ -387,5 +455,6 @@
 void cleanup_module(void)
 {
 	unregister_framebuffer(&fb_info);
+	release_mem_region(fb_info.fb_virt_start, fb_info.fb_size);
 }
 #endif /* MODULE */
Index: drivers/video/ts7kvfb.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/video/ts7kvfb.h,v
retrieving revision 1.1
retrieving revision 1.3
diff -u -r1.1 -r1.3
--- drivers/video/ts7kvfb.h	9 Sep 2005 17:36:30 -0000	1.1
+++ drivers/video/ts7kvfb.h	25 Jan 2006 22:48:32 -0000	1.3
@@ -1,11 +1,21 @@
-#define XRES  640
-#define YRES  480 
-#define BPP   16
+//TS7KV base address
+#define TS7KV_ID0	0x41
+#define TS7KV_ID1	0x20
 
-#define CONFIG_REG  0xF0
-#define DONE_MSK    0x80
+//TS7KV base addresses/sizes
+#define BASE_ADDR	0xE0
+#define BASE_SIZE	0x8
+#define REGS_ADDR	0x00
+#define REGS_SIZE	0x20
 
-#define VIDEOMEMORYSIZE (1*1024*1024)
+//TS7KV control registers
+#define ID0_REG	0
+#define ID1_REG	1
+#define PLD_REG	2
+#define CTR_REG0	4
+#define CTR_REG1	5
+#define FWD_REG	6
+#define JMP_REG	7
 
 //FPGA video registers
 #define BLTCTRL 0
@@ -15,4 +25,13 @@
 #define VIDCTRL 4
 #define DEVSEL  15
 
+#define CRT       0
+#define LCD_MONO  1
+
+#define BPP   16
+
+#define VIDEOMEMORYSIZE (1*1024*1024)
+
+//FPGA Loaded
+#define DONE_MSK    0x80
 
Index: drivers/video/vesafb.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/video/vesafb.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/video/vesafb.c	22 Jul 2004 19:50:23 -0000	1.1
+++ drivers/video/vesafb.c	4 Aug 2004 01:29:59 -0000	1.2
@@ -93,7 +93,12 @@
 } fbcon_cmap;
 
 static int             inverse   = 0;
+#ifdef __x86_64__
+static int             mtrr      = 1;
+#else
 static int             mtrr      = 0;
+#endif
+static int	 vram __initdata = 0;	/* needed for vram boot option */
 static int             currcon   = 0;
 
 static int             pmi_setpal = 0;	/* pmi for palette changes ??? */
@@ -479,6 +484,10 @@
 			pmi_setpal=1;
 		else if (! strcmp(this_opt, "mtrr"))
 			mtrr=1;
+		/* checks for vram boot option */
+		else if (! strncmp(this_opt, "vram:", 5))
+			vram = simple_strtoul(this_opt+5, NULL, 0);
+
 		else if (!strncmp(this_opt, "font:", 5))
 			strcpy(fb_info.fontname, this_opt+5);
 	}
@@ -520,7 +529,20 @@
 	video_width         = screen_info.lfb_width;
 	video_height        = screen_info.lfb_height;
 	video_linelength    = screen_info.lfb_linelength;
-	video_size          = screen_info.lfb_width *	screen_info.lfb_height * video_bpp;
+
+	/* remap memory according to videomode, multiply by 2 to get space for doublebuffering */
+	video_size          = screen_info.lfb_width *	screen_info.lfb_height * video_bpp / 8 * 2;
+
+	/* check that we don't remap more memory than old cards have */
+	if (video_size > screen_info.lfb_size * 65536)
+		video_size = screen_info.lfb_size * 65536;
+	
+	/* FIXME: Should we clip against declared size for banked devices ? */
+	
+	/* sets video_size according to vram boot option */
+	if (vram && vram * 1024 * 1024 != video_size)
+		video_size = vram * 1024 * 1024;
+		
 	video_visual = (video_bpp == 8) ?
 		FB_VISUAL_PSEUDOCOLOR : FB_VISUAL_TRUECOLOR;
 
Index: drivers/video/vga16fb.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/video/vga16fb.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/video/vga16fb.c	22 Jul 2004 19:50:23 -0000	1.1
+++ drivers/video/vga16fb.c	4 Aug 2004 01:29:59 -0000	1.2
@@ -142,7 +142,7 @@
 	memset(fix, 0, sizeof(struct fb_fix_screeninfo));
 	strcpy(fix->id,"VGA16 VGA");
 
-	fix->smem_start = VGA_FB_PHYS;
+	fix->smem_start = VGA_MAP_MEM(VGA_FB_PHYS);
 	fix->smem_len = VGA_FB_PHYS_LEN;
 	fix->type = FB_TYPE_VGA_PLANES;
 	fix->visual = FB_VISUAL_PSEUDOCOLOR;
@@ -896,7 +896,7 @@
 
 	/* XXX share VGA_FB_PHYS region with vgacon */
 
-        vga16fb.video_vbase = ioremap(VGA_FB_PHYS, VGA_FB_PHYS_LEN);
+        vga16fb.video_vbase = ioremap(VGA_MAP_MEM(VGA_FB_PHYS), VGA_FB_PHYS_LEN);
 	if (!vga16fb.video_vbase) {
 		printk(KERN_ERR "vga16fb: unable to map device\n");
 		return -ENOMEM;
Index: drivers/video/aty/atyfb.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/video/aty/atyfb.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/video/aty/atyfb.h	22 Jul 2004 19:50:23 -0000	1.1
+++ drivers/video/aty/atyfb.h	4 Aug 2004 01:29:59 -0000	1.2
@@ -4,7 +4,8 @@
  */
 
 #include <linux/config.h>
-
+#include <linux/sched.h>
+#include <linux/compiler.h>
 
     /*
      *  Elements of the hardware specific atyfb_par structure
@@ -15,7 +16,6 @@
     u32 vyres;
     u32 xoffset;
     u32 yoffset;
-    u32 bpp;
     u32 h_tot_disp;
     u32 h_sync_strt_wid;
     u32 v_tot_disp;
@@ -24,6 +24,17 @@
     u32 gen_cntl;
     u32 dp_pix_width;	/* acceleration */
     u32 dp_chain_mask;	/* acceleration */
+#ifdef CONFIG_FB_ATY_GENERIC_LCD
+    u32 monitors_enabled; /* LCD monitor support */
+    u16 h_stretching;     /* LCD monitor support */
+    u16 v_stretching;     /* LCD monitor support */
+#endif
+    u8 bpp;
+    u8 h_blank_start;
+    u8 h_blank_end;
+    u16 v_blank_start;
+    u8 v_blank_end;
+    u8 genmo;
 };
 
 struct pll_514 {
@@ -40,16 +51,17 @@
 };
 
 struct pll_ct {
-    u8 pll_ref_div;
-    u8 pll_gen_cntl;
-    u8 mclk_fb_div;
+//    u8 pll_ref_div;
+//    u8 pll_gen_cntl;
+//    u8 mclk_fb_div;
     u8 pll_vclk_cntl;
     u8 vclk_post_div;
     u8 vclk_fb_div;
-    u8 pll_ext_cntl;
+//    u8 alt_post_div;
+//    u8 pll_ext_cntl;
     u32 dsp_config;	/* Mach64 GTB DSP */
     u32 dsp_on_off;	/* Mach64 GTB DSP */
-    u8 mclk_post_div_real;
+//    u8 mclk_post_div_real;
     u8 vclk_post_div_real;
 };
 
@@ -89,11 +101,42 @@
 struct fb_info_aty {
     struct fb_info fb_info;
     struct fb_info_aty *next;
+    u32* ati_regaddr[256];
     unsigned long ati_regbase_phys;
     unsigned long ati_regbase;
     unsigned long frame_buffer_phys;
     unsigned long frame_buffer;
     unsigned long clk_wr_offset;
+#ifdef CONFIG_FB_ATY_CT
+    u8 pll_ref_div;
+    u8 xclk_post_div_real;
+    u16 mclk_fb_div;
+    u8 fifo_size;
+    u8 dsp_loop_latency;
+//    u8 page_size;
+    u8 xclkpagefaultdelay,xclkmaxrasdelay;
+#endif
+#ifdef CONFIG_FB_ATY_GENERIC_LCD
+    unsigned long bios_base_phys;
+    unsigned long bios_base;
+    unsigned long lcd_table;
+    u16 lcd_width;
+    u16 lcd_height;
+    u32 lcd_pixclock;
+    u16 lcd_htotal;
+    u16 lcd_hdisp;
+    u16 lcd_hsync_start;
+    u16 lcd_hsync_delay;
+    u16 lcd_hsync_width;
+    u16 lcd_vtotal;
+    u16 lcd_vdisp;
+    u16 lcd_vsync_start;
+    u16 lcd_vsync_width;
+    u16 lcd_right;
+    u16 lcd_lower;
+    u16 lcd_hblank_width;
+    u16 lcd_vblank_width;
+#endif
     struct pci_mmap_map *mmap_map;
     struct aty_cursor *cursor;
     struct aty_cmap_regs *aty_cmap_regs;
@@ -105,6 +148,7 @@
     u32 ref_clk_per;
     u32 pll_per;
     u32 mclk_per;
+    u32 xclk_per;
     u8 bus_type;
     u8 ram_type;
     u8 mem_refresh_rate;
@@ -124,6 +168,7 @@
 #endif
     } fbcon_cmap;
     u8 blitter_may_be_busy;
+    u8 font_loaded;
 #ifdef __sparc__
     u8 mmaped;
     int open;
@@ -164,6 +209,12 @@
 #define M64F_LT_SLEEP		0x00040000
 #define M64F_XL_DLL		0x00080000
 
+#ifdef __i386__
+#   define stdcall	__attribute__ ((stdcall))
+#else
+#   define stdcall
+#endif
+#define packed		__attribute__ ((packed))
 
     /*
      *  Register access
@@ -172,70 +223,72 @@
 static inline u32 aty_ld_le32(int regindex,
 			      const struct fb_info_aty *info)
 {
-    /* Hack for bloc 1, should be cleanly optimized by compiler */
-    if (regindex >= 0x400)
-	regindex -= 0x800;
+    if (regindex >= 0x400) {
+        regindex -= 0x800;
+#if defined(__mc68000__)
+        return le32_to_cpu(*((volatile u32 *)(info->ati_regbase+regindex)));
+#else
+        return readl (info->ati_regbase + regindex);
+#endif
+    } else {
+#if defined(__mc68000__)
+        return le32_to_cpu(*((volatile u32 *)(info->ati_regaddr[regindex/4])));
+#else
+        return readl (info->ati_regaddr[regindex/4]);
+#endif
+    };
+}
 
-#ifdef CONFIG_ATARI
-    return in_le32((volatile u32 *)(info->ati_regbase+regindex));
+static inline void aty_st_le32_sr(int regindex, u32 val,
+			         const struct fb_info_aty *info)
+{
+#if defined(__mc68000__)
+    *((volatile u32 *)(info->ati_regaddr[regindex/4])) = cpu_to_le32(val);
 #else
-    return readl (info->ati_regbase + regindex);
+    writel (val,info->ati_regaddr[regindex/4]);
 #endif
 }
 
 static inline void aty_st_le32(int regindex, u32 val,
 			       const struct fb_info_aty *info)
 {
-    /* Hack for bloc 1, should be cleanly optimized by compiler */
-    if (regindex >= 0x400)
-	regindex -= 0x800;
-
-#ifdef CONFIG_ATARI
-    out_le32 (info->ati_regbase+regindex, val);
+    if (regindex >= 0x400) {
+        regindex -= 0x800;
+#if defined(__mc68000__)
+        *((volatile u32 *)(info->ati_regbase+regindex)) = cpu_to_le32(val);
+#else
+        writel (val,info->ati_regbase + regindex);
+#endif
+    } else {
+#if defined(__mc68000__)
+        *((volatile u32 *)(info->ati_regaddr[regindex/4])) = cpu_to_le32(val);
 #else
-    writel (val, info->ati_regbase + regindex);
+        writel (val,info->ati_regaddr[regindex/4]);
 #endif
+    };
 }
 
 static inline u8 aty_ld_8(int regindex,
 			  const struct fb_info_aty *info)
 {
-    /* Hack for bloc 1, should be cleanly optimized by compiler */
     if (regindex >= 0x400)
-	regindex -= 0x800;
-
-#ifdef CONFIG_ATARI
-    return in_8 (info->ati_regbase + regindex);
-#else
+        regindex -= 0x800;
     return readb (info->ati_regbase + regindex);
-#endif
 }
 
 static inline void aty_st_8(int regindex, u8 val,
 			    const struct fb_info_aty *info)
 {
-    /* Hack for bloc 1, should be cleanly optimized by compiler */
     if (regindex >= 0x400)
-	regindex -= 0x800;
-
-#ifdef CONFIG_ATARI
-    out_8 (info->ati_regbase + regindex, val);
-#else
-    writeb (val, info->ati_regbase + regindex);
-#endif
+        regindex -= 0x800;
+    writeb (val,info->ati_regbase + regindex);
 }
 
-static inline u8 aty_ld_pll(int offset, const struct fb_info_aty *info)
-{
-    u8 res;
-
-    /* write addr byte */
-    aty_st_8(CLOCK_CNTL + 1, (offset << 2), info);
-    /* read the register value */
-    res = aty_ld_8(CLOCK_CNTL + 2, info);
-    return res;
-}
+    /* 
+     * Mach64 CT PLL operations
+     */
 
+extern u8 aty_ld_pll(int offset, const struct fb_info_aty *info) stdcall;
 
     /*
      *  DAC operations
@@ -259,10 +312,11 @@
 
 struct aty_pll_ops {
     int (*var_to_pll)(const struct fb_info_aty *info, u32 vclk_per, u8 bpp,
-		      union aty_pll *pll);
+		      u32 xres, union aty_pll *pll);
     u32 (*pll_to_var)(const struct fb_info_aty *info,
 	    	      const union aty_pll *pll);
     void (*set_pll)(const struct fb_info_aty *info, const union aty_pll *pll);
+    void (*init_pll)(struct fb_info_aty *info);
 };
 
 extern const struct aty_pll_ops aty_pll_ati18818_1;	/* ATI 18818 */
@@ -276,8 +330,8 @@
 
 extern void aty_set_pll_ct(const struct fb_info_aty *info,
 			   const union aty_pll *pll);
-extern void aty_calc_pll_ct(const struct fb_info_aty *info,
-			    struct pll_ct *pll);
+//extern void aty_calc_pll_ct(const struct fb_info_aty *info,
+//			    struct pll_ct *pll);
 
 
     /*
@@ -297,7 +351,7 @@
 
 static inline void wait_for_fifo(u16 entries, const struct fb_info_aty *info)
 {
-    while ((aty_ld_le32(FIFO_STAT, info) & 0xffff) >
+    while (__builtin_expect((aty_ld_le32(FIFO_STAT, info) & 0xffff), 0) >
 	   ((u32)(0x8000 >> entries)));
 }
 
@@ -305,20 +359,21 @@
 {
     wait_for_fifo(16, info);
     while ((aty_ld_le32(GUI_STAT, info) & 1)!= 0);
-    info->blitter_may_be_busy = 0;
+      info->blitter_may_be_busy = 0;
 }
 
 extern void aty_reset_engine(const struct fb_info_aty *info);
 extern void aty_init_engine(const struct atyfb_par *par,
 			    struct fb_info_aty *info);
 extern void aty_rectfill(int dstx, int dsty, u_int width, u_int height,
-			 u_int color, struct fb_info_aty *info);
+                         u_int color, struct fb_info_aty *info);
 
 
     /*
      *  Text console acceleration
      */
 
+extern const struct display_switch fbcon_aty0;
 extern const struct display_switch fbcon_aty8;
 extern const struct display_switch fbcon_aty16;
 extern const struct display_switch fbcon_aty24;
